-- NoteAnnouncer
-- Version 0.1.4
-- Created By: Mortur
-- Special thanks to: Eleran, Akea - for helping to test!

local NoteAnnouncer = {}

local frame = CreateFrame("Frame", nil, PlayerFrame)

frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", function()
  if event == "PLAYER_ENTERING_WORLD" then
    NoteAnnouncer:Initialize()
  end
end)

NoteAnnouncer.frame = frame


function NoteAnnouncer:Initialize()
  ChatFrame1:AddMessage("NoteAnnouncer Loaded...")
  
  NoteAnnouncer.frame:RegisterEvent("CHAT_MSG_SYSTEM")
  NoteAnnouncer.frame:SetScript("OnEvent", RelayMessagetest)
  -- ChatFrame1:AddMessage("NoteAnnouncer Finished Loading")
end



function RelayMessagetest(this, event, ...)
  -- ChatFrame1:AddMessage("Testing for Firing - "..event)
  if event == "CHAT_MSG_SYSTEM" then
  
    
    
    local systemMessage = ...
    -- ChatFrame1:AddMessage(systemMessage .. " - Testing")
    
    if string.sub(systemMessage, -16, -1) == "has come online." then
    
      local saveRosterSetting = GetGuildRosterShowOffline()
      
      SetGuildRosterShowOffline(1)
    
      local loginPlayerName = string.sub(systemMessage, 1, -17)
      
      -- ChatFrame1:AddMessage("Name Test: " .. loginPlayerName)
      
      -- local j = 1
      -- while (j <= string.len(loginPlayerName)) do
        
      --   ChatFrame1:AddMessage(string.sub(systemMessage, j, j))
        
      --   j = j + 1
      -- end
      
      local startCut = string.find(loginPlayerName, ":")
      local endCut = string.find(loginPlayerName, "|h")
      
      local cleanName = string.sub(loginPlayerName, startCut + 1, endCut - 1)
      
      -- ChatFrame1:AddMessage("Cleaned Name Test: ***" .. cleanName .. "***")
    
    
      local playername = cleanName
      local GuildName, GuildRankName, GuildRankIndex = GetGuildInfo(playername)
      
      -- ChatFrame1:AddMessage(GuildName .. " - " .. GuildRankName .. " - " .. GuildRankIndex)
      
      local numMembers = GetNumGuildMembers()
      
      
      local i = 1
      while (i <= numMembers) do
        local name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName  = GetGuildRosterInfo(i)
        
        if (name == playername) then
          ChatFrame1:AddMessage("|cFFFFFF00Rank: |r" .. rank .. "  |cFFFFFF00Guild Note: |r" .. note)
          
          i = numMembers
        end
        
        i = i + 1
      end
      
      
      local numFriends = GetNumFriends()
      
      local k = 1
      while (k <= numFriends) do
        local name, level , class, loc, connected, status, note = GetFriendInfo(k);
        
        if (name == playername) then
          
          if (note == nil) then
            note = " "
          end          
          
          ChatFrame1:AddMessage("|cFFFFFF00Friend Note: |r" .. note)
          
          k = numMembers
        end
        
        k = k + 1
      end
      
      
      
      
      
      SetGuildRosterShowOffline(saveRosterSetting)
      
    else
      
      -- ChatFrame1:AddMessage("This was not a login - ignoring")
    
    end
    
  end
end